from datetime import datetime
from typing import Dict

class UserTrust:
    def __init__(self, use_case: str, context: str, user: str, t: float, last_update: datetime):
        self.use_case = use_case
        self.context = context
        self.user = user
        self.t = t
        self.last_update = last_update

    
    def to_serializable_dict(self):
        return {
            "use_case": self.use_case,
            "context": self.context,
            "user": self.user,
            "t": self.t,
            "last_update": self.last_update
        }
    
    @staticmethod
    def from_serializable_dict(data: Dict):
        if "use_case" not in data.keys() or "context" not in data.keys() or "user" not in data.keys() or "t" not in data.keys() or "last_update" not in data.keys():
            raise ValueError("Missing fields for User!")

        return UserTrust(data["use_case"], data["context"], data["user"], data["t"], data["last_update"])