from lib.database.entities.context import Context
from lib.database.repositories.context_repository import ContextRepository
from flask import request, Response

context_repository: ContextRepository = ContextRepository()

def add(use_case: str):
    data = request.json

    context_new = None
    try:
        context_new = Context.from_serializable_dict(data)
    except ValueError:
        return Response(status=400, response="Missing fields in request")
    
    if context_new.use_case != use_case:
        return Response(status = 400, response="Use-Cases in body and url do not match!")
    
    context_repository.add(context_new)

    return context_new.to_serializable_dict()

def all_for_use_case(use_case: str):
    return context_repository.all_for_use_case(use_case)
